var Sequelize = require("sequelize");
var hashlib   = require("hashlib");

var sequelize = new Sequelize('lape', 'lape', 'lape', {
  host: "localhost",
  port: 3306
});

var User = sequelize.define('User', {
  id: { type: Sequelize.INTEGER, autoIncrement: true, primaryKey: true },
  username: { type: Sequelize.STRING, unique: true },
  password: Sequelize.STRING,
  is_active: { type: Sequelize.BOOLEAN, allowNull: false, defaultValue: false },
  activation_key: { type: Sequelize.STRING }
},{
  paranoid: true,
  underscore: true,
  classMethods: {
    retrieveByUsername: function(username, success, failure){ 
      User.find({ where: {username: username} }).on('success', function(user) {
    	  if(success) {
    		  success(user);
    	  }
      }).on('failure', function(e) {
          if(failure) {
        	  failure(e);
          }
      });
    }
  },
  instanceMethods: {
    activate: function(success, failure) { 
      this.updateAttributes({
        is_active: true
      }).on('success', function() {
          if(success) success(this);
      }).on('failure', function() {
    	  if(failure) failure(this);  
      });
    }
  }
});

module.exports.activate = function(username, success, failure) {
  User.retrieveByUsername(username, function(user, success, failure){
    if(user) {
      user.activate(success, failure);
    }
  });
}

module.exports.register = function(username, password) {
  var user = User.build({username: username, password: hashlib.md5(password)});
  user.save();
}

module.exports.check = function(username, password, success, failure) {
  User.retrieveByUsername(username, function(user) {
//    console.log(hashlib.md5(password), user.password);
    if(hashlib.md5(password) == user.password) success();
    if(!user && failure) failure('No user');
  });
}


//sequelize.sync();
